Whamcloud - gitweb
LU-9744 mdt: avoid wrong CLF_HSM_DIRTY report in ChangeLog
[fs/lustre-release.git] / lustre / tests / sanity-benchmark.sh
index ca97c75..5ea7a0c 100644 (file)
@@ -14,6 +14,9 @@ init_test_env $@
 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 init_logging
 
+# bug number:
+ALWAYS_EXCEPT="$SANITY_BENCHMARK_EXCEPT"
+
 MAX_THREADS=${MAX_THREADS:-20}
 RAMKB=`awk '/MemTotal:/ { print $2 }' /proc/meminfo`
 if [ -z "$THREADS" ]; then
@@ -26,16 +29,7 @@ RSIZE=${RSIZE:-512}
 DEBUG_LVL=${DEBUG_LVL:-0}
 DEBUG_OFF=${DEBUG_OFF:-"eval lctl set_param debug=\"$DEBUG_LVL\""}
 DEBUG_ON=${DEBUG_ON:-"eval lctl set_param debug=0x33f0484"}
-
-PIOSBIN=${PIOSBIN:-$(which pios 2> /dev/null || true)}
-
-pios_THREADCOUNT=${pios_THREADCOUNT:-"1,8,40"}
-[ "$SLOW" = "no" ] && pios_THREADCOUNT=8
-
-pios_REGIONCOUNT=${pios_REGIONCOUNT:-1024}
-pios_CHUNKSIZE=${pios_CHUNKSIZE:-1M}
-pios_REGIONSIZE=${pios_REGIONSIZE:-8M}
-pios_OFFSET=${pios_OFFSET:-16M}
+DIRECTIO=${DIRECTIO:-directio}
 
 [ "$SLOW" = "no" ] && EXCEPT_SLOW="iozone"
 
@@ -140,7 +134,7 @@ test_iozone() {
     # check if O_DIRECT support is implemented in kernel
     if [ -z "$O_DIRECT" ]; then
        touch $DIR/f.iozone
-       if ! ./directio write $DIR/f.iozone 0 1; then
+       if ! $DIRECTIO write $DIR/f.iozone 0 1; then
            log "SKIP iozone DIRECT IO test"
            O_DIRECT=no
        fi
@@ -190,118 +184,15 @@ test_fsx() {
     FSX_SEED=${FSX_SEED:-$RANDOM}
     rm -f $testfile
     $LFS setstripe -c -1 $testfile
-    echo Using FSX_SEED=$FSX_SEED FSX_SIZE=$FSX_SIZE FSX_COUNT=$FSX_COUNT
-    fsx -c 50 -p 1000 -S $FSX_SEED -P $TMP -l $FSX_SIZE \
-       -N $(($FSX_COUNT * 100)) $DIR/fsxfile
+    CMD="fsx -c 50 -p 1000 -S $FSX_SEED -P $TMP -l $FSX_SIZE \
+        -N $((FSX_COUNT * 100)) $FSXOPT $testfile"
+    echo "Using: $CMD"
+    $CMD || error "fsx failed"
+    rm -f $testfile
     $DEBUG_ON
 }
 run_test fsx "fsx"
 
-
-############################################################
-# PIOS
-#
-
-iterpr_KMGT () {
-    local str=$1
-    local num=${str:0:${#str}-1}
-    case ${str:${#str}-1} in
-        k|K ) num=$((num << 10));; #
-        m|M ) num=$((num << 20));; # emacs is confsued by the <<  and
-        g|G ) num=$((num << 30));; # these comments help it out.
-        t|T ) num=$((num << 40));; #
-          * ) num=$str;;
-    esac
-    echo $num
-}
-
-space_check () {
-    # space estimation
-    # /* Adding 10% to total test size for filesystem overhead */
-    #  size = size + (double)(size) * (double) (0.1);
-    # 
-    #  total_test_size = runarg->stream[n - 1].max_offset +
-    #                            runarg->regionsize;
-
-    local space=$(df -P $DIR | tail -n 1 | awk '{ print $4 }')
-    local size=$(($(iterpr_KMGT $pios_REGIONCOUNT) * \
-                  $(iterpr_KMGT $pios_OFFSET) + \
-                  $(iterpr_KMGT $pios_REGIONSIZE) ))
-    size=$(( size + size / 10 ))
-    if [ $((space * 1024)) -le $size ]; then 
-        echo "Need free space atleast $size, have $((space * 1024))"
-        return 10
-    fi
-}
-
-pios_setup() { 
-    local testdir=$DIR/$tdir
-    mkdir -p $testdir
-
-    stripes=1
-    [ "$1" == "--stripe" ] && stripes=-1
-    $LFS setstripe $testdir -c $stripes
-    echo "Test directory stripe count: $stripes"
-}
-
-pios_cleanup() {
-    local rc=$1
-    local testdir=$DIR/$tdir
-    [ $rc = 0 ] && rm -rf $testdir
-}
-
-run_pios () {
-    local testdir=$DIR/$tdir
-    local cmd="$PIOSBIN  -t $pios_THREADCOUNT -n $pios_REGIONCOUNT \
-                         -c $pios_CHUNKSIZE -s $pios_REGIONSIZE    \
-                         -o $pios_OFFSET  $@ -p $testdir"
-    
-    if [ ! -d $testdir ]; then  
-        error "No test directory created, setup_pios must have failed"
-        return 20
-    fi
-
-    log "$cmd"
-
-    local rc=0
-    eval $cmd
-    rc=$?
-
-    return $rc
-}
-
-test_pios_ssf() {
-    if  [ -z "$PIOSBIN" ]; then
-        skip_env "$0 : pios not found PIOSBIN=$PIOSBIN"
-       return
-    fi
-
-    local rc=0
-    space_check || { skip_env "not enough space" && return 0; }
-    pios_setup --stripe || return
-    run_pios || return
-    run_pios  --verify || rc=$? 
-    pios_cleanup $rc
-    return $rc
-}
-run_test pios_ssf "pios shared single file"
-
-test_pios_fpp() {
-    if  [ -z "$PIOSBIN" ]; then
-        skip_env "pios not found PIOSBIN=$PIOSBIN"
-        return
-    fi
-
-    local rc=0
-    space_check || { skip_env "not enough space" && return 0; }
-    pios_setup || return
-    run_pios -L fpp || return
-    run_pios -L fpp --verify || rc=$?
-    pios_cleanup $rc
-    return $rc
-}
-run_test pios_fpp "pios file per process"
-
-equals_msg `basename $0`: test complete, cleaning up
+complete $SECONDS
 check_and_cleanup_lustre
-[ -f "$TESTSUITELOG" ] && cat $TESTSUITELOG && grep -q FAIL $TESTSUITELOG && exit 1 || true
+exit_status